package cofh.thermal.expansion.block.entity.machine;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.util.helpers.FluidHelper;
import cofh.lib.api.StorageGroup;
import cofh.lib.fluid.FluidStorageCoFH;
import cofh.lib.inventory.ItemStorageCoFH;
import cofh.thermal.core.config.ThermalCoreConfig;
import cofh.thermal.core.util.managers.machine.RefineryRecipeManager;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.expansion.inventory.container.machine.MachineRefineryContainer;
import cofh.thermal.lib.block.entity.MachineBlockEntity;
import cofh.thermal.lib.util.recipes.IMachineInventory;
import cofh.thermal.lib.util.recipes.IThermalInventory;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.material.Fluids;
import net.minecraftforge.fluids.FluidStack;

public class MachineRefineryTile extends MachineBlockEntity {
  protected ItemStorageCoFH outputSlot = new ItemStorageCoFH();
  
  protected FluidStorageCoFH inputTank;
  
  protected FluidStorageCoFH outputTankA;
  
  protected FluidStorageCoFH outputTankB;
  
  public MachineRefineryTile(BlockPos pos, BlockState state) {
    super((BlockEntityType)TExpTileEntities.MACHINE_REFINERY_TILE.get(), pos, state);
    this.inputTank = new FluidStorageCoFH(4000, fluid -> (this.filter.valid(fluid) && RefineryRecipeManager.instance().validRecipe(fluid)));
    this.outputTankA = new FluidStorageCoFH(8000);
    this.outputTankB = new FluidStorageCoFH(8000);
    this.inventory.addSlot(this.outputSlot, StorageGroup.OUTPUT);
    this.inventory.addSlot(this.chargeSlot, StorageGroup.INTERNAL);
    this.tankInv.addTank(this.inputTank, StorageGroup.INPUT);
    this.tankInv.addTank(this.outputTankA, StorageGroup.OUTPUT);
    this.tankInv.addTank(this.outputTankB, StorageGroup.OUTPUT);
    this.renderFluid = new FluidStack((Fluid)Fluids.f_76193_, 1000);
    addAugmentSlots(ThermalCoreConfig.machineAugments);
    initHandlers();
  }
  
  protected int getBaseProcessTick() {
    return RefineryRecipeManager.instance().getBasePower();
  }
  
  protected boolean cacheRecipe() {
    this.curRecipe = RefineryRecipeManager.instance().getRecipe((IThermalInventory)this);
    if (this.curRecipe != null)
      this.fluidInputCounts = this.curRecipe.getInputFluidCounts((IMachineInventory)this); 
    return (this.curRecipe != null);
  }
  
  protected boolean cacheRenderFluid() {
    if (this.curRecipe == null)
      return false; 
    if (this.inputTank.isEmpty())
      return false; 
    FluidStack prevFluid = this.renderFluid;
    this.renderFluid = new FluidStack(this.inputTank.getFluidStack(), 1000);
    return !FluidHelper.fluidsEqual(this.renderFluid, prevFluid);
  }
  
  @Nullable
  public AbstractContainerMenu m_7208_(int i, Inventory inventory, Player player) {
    return (AbstractContainerMenu)new MachineRefineryContainer(i, this.f_58857_, this.f_58858_, inventory, player);
  }
  
  protected boolean validateInputs() {
    if (!cacheRecipe())
      return false; 
    return (this.inputTank.getAmount() >= ((Integer)this.fluidInputCounts.get(0)).intValue());
  }
}
